<template>
  <loader
    class="meal-food-inner"
    :class="{ 'is-temp': activity.temp }"
    :loading="loading"
    size="sm"
    @click.native="loading || retry ? '' : (deleting = !deleting)"
  >
    <v-icon v-if="retry" class="ic-status text-warning" name="alert-triangle" />
    <v-icon v-else-if="!activity.temp" class="ic-status" name="check-circle" />
    <div
      class="item-image"
      :style="{ backgroundImage: `url('${activity.image}')` }"
    />
    <div class="item-name text-truncate mt-3 mb-4">
      {{ activity.activityTitle }}
    </div>
    <ul class="item-footer">
      <li>
        <span>{{ activity.calorie }}</span>
        <span>کالری</span>
      </li>
      <li>
        <span>{{ activity.amount }}</span>
        <span class="text-truncate">دقیقه</span>
      </li>
    </ul>
    <div v-if="retry && !loading" class="cover retry-save-food">
      <div class="text-danger" @click.prevent.stop="save">
        <v-icon name="refresh-cw" width="26" />
        <p>تلاش مجدد</p>
      </div>
    </div>
    <div v-if="deleting" class="cover delete-food">
      <div class="text-danger" @click.prevent.stop="deleteActivity">
        <v-icon name="trash-2" width="26" />
        <p>حذف</p>
      </div>
      <div style="color:rgb(243, 114, 0)">
        <v-icon name="x" width="26" />
        <p>لغو</p>
      </div>
    </div>
  </loader>
</template>

<script>
export default {
  name: 'ActivityItem',
  props: {
    activity: { type: Object, default: () => ({}) }
  },
  data() {
    return {
      loading: false,
      deleting: false
    }
  },
  computed: {
    retry() {
      return this.activity.status === 'fail'
    }
  },
  created() {
    if (this.activity.temp) {
      this.loading = true
      this.save()
      this.$emit('show-me')
    }
  },
  methods: {
    deleteActivity() {
      this.$store
        .dispatch('activity/deleteActivity', {
          $vm: this,
          $data: { id: this.activity.id }
        })
        .then(() => this.$emit('delete'))
    },
    save() {
      let activity = this.activity
      this.$store
        .dispatch('activity/addActivity', {
          $vm: this,
          $data: {
            action_id: activity.activityId,
            amount: activity.amount,
            date: activity.date,
            oldId: activity.id
          }
        })
        .then(() => {
          this.$emit('update')
        })
    }
  }
}
</script>
